/**
 * Copyright (c) 2022 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../libs.h"
#include "../assert/assert.h"
#include "../util/array.h"

#define SCENE_ITEM_COUNT_MAX 1024

typedef struct _sceneitem_t sceneitem_t;
typedef struct _scenemanager_t scenemanager_t;

typedef void scenerender_t(sceneitem_t *item);

typedef struct _sceneitem_t {
  void *user;
  uint8_t flags;
  scenerender_t *onRender;
} sceneitem_t;

typedef struct _scenemanager_t {
  sceneitem_t items[SCENE_ITEM_COUNT_MAX];
  int32_t itemCount;
} scenemanager_t;

void sceneManagerInit(scenemanager_t *sceneManager);